#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}

#define int long long
#define double long double
#define endl '\n'
const int N=2e5+10,MOD=1e9+7,INF=2e18;

void solve() {
    int n,m,k;
    cin>>n>>m>>k;
    vector<vector<int>> gr(n);
    for(int i=0;i<m;i++){
        int u,v;
        cin>>u>>v;
        u--;v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    set<pair<int,int>> q;
    vector<int> can(n,-INF);
    for(int i=0;i<k;i++){
        int p,h;
        cin>>p>>h;
        p--;
        can[p]=h;
        q.insert({-can[p],p});
    }

    while(!q.empty()){
        int v=q.begin()->second;
        q.erase(q.begin());
        for(auto to:gr[v]){
            if(can[to]<can[v]-1){
                q.erase({-can[to],to});
                can[to]=can[v]-1;
                q.insert({-can[to],to});
            }
        }
    }

    vector<int> ans;
    for(int i=0;i<n;i++){
        if(can[i]>=0){
            ans.push_back(i);
        }
    }

    cout<<ans.size()<<endl;
    for(auto c:ans){
        cout<<c+1<<" ";
    }cout<<endl;
}