#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}

#define int long long
#define double long double
#define endl '\n'
const int N=2e5+10,MOD=1e9+7,INF=2e18;

struct point{
    double x,y;


};
double dist(point o,point a){
    return sqrt((o.x-a.x)*(o.x-a.x)+(o.y-a.y)*(o.y-a.y));
}
double tme=clock();
void solve() {
    int n;
    cin>>n;
    vector<point> a(n);
    for(int i=0;i<n;i++){
        cin>>a[i].x>>a[i].y;
    }
    vector<int> p(n);
    iota(p.begin(),p.end(),0);
    double ans=INF;
    cout<<fixed<<setprecision(15);
    do{
        for(int start=1;start<n;start++) {
            double cur=0;
            bool gor=false;
            bool vert=false;
            double k=0,b=0;
            point f = a[p[start - 1]], s = a[p[start]];
            cur += dist(f, s);
            if (f.x == s.x) {
                vert = true;
            } else if (f.y == s.y) {
                gor = true;
            } else {
                k = (double) (s.y - f.y) / (s.x - f.x);
                b = f.y - k * f.x;
            }

            for (int i = start+1; i < n; i++) {
                f = a[p[i - 1]], s = a[p[i]];
                point iv;
                if (gor) {
                    iv = {s.x, f.y};
                } else if (vert) {
                    iv = {s.x, f.y};
                } else {
                    double ks = k;
                    double bs = s.y - ks * s.x;
                    b = f.y + (1 / k) * f.x;
                    k = -1 / k;
                    double xint = (b - bs) / (ks - k);
                    double yint = ks * xint + bs;
                    k = ks;
                    b = bs;
                    iv = {xint, yint};
                }
                cur += dist(f, iv);
                cur += dist(iv, s);
                if(cur>ans)break;
            }
            for (int i = start-2; i >=0;i--) {
                f = a[p[i+1]], s = a[p[i]];
                point iv;
                if (gor) {
                    iv = {s.x, f.y};
                } else if (vert) {
                    iv = {s.x, f.y};
                } else {
                    double ks = k;
                    double bs = s.y - ks * s.x;
                    b = f.y + (1 / k) * f.x;
                    k = -1 / k;
                    double xint = (b - bs) / (ks - k);
                    double yint = ks * xint + bs;
                    k = ks;
                    b = bs;
                    iv = {xint, yint};
                }
                cur += dist(f, iv);
                cur += dist(iv, s);
                if(cur>ans)break;
            }
            ans=min(ans,cur);
            if((clock()-tme)/CLOCKS_PER_SEC>3.4){
                break;
            }
        }
        if((clock()-tme)/CLOCKS_PER_SEC>3.4){
            break;
        }
    }while(next_permutation(p.begin(),p.end()));
    cout<<ans<<endl;
}